--
-- FS19 - Mountable attacher
-- @author:    	kenny456 (kenny456@seznam.cz)
-- @history:	v1.0.0.0 - 2020-12-27 - first release
--
source(Utils.getFilename("mountableAttacher.lua", g_currentModDirectory))

MountableAttacher_register = {}

function MountableAttacher_register:loadMap()
end
function MountableAttacher_register:register(name)
	if g_specializationManager:getSpecializationByName("MountableAttacher") == nil then
		if MountableAttacher == nil then 
			print("ERROR: unable to add specialization 'MountableAttacher'")
		else 
			for i, typeDef in pairs(g_vehicleTypeManager.vehicleTypes) do
				if typeDef ~= nil and i ~= "locomotive" then 
					local isAttacherJoints  = false
					for name, spec in pairs(typeDef.specializationsByName) do
						if name == "attacherJoints"  then 
							isAttacherJoints = true 
						end 
					end
					if isAttacherJoints then
					  typeDef.specializationsByName["MountableAttacher"] = MountableAttacher
					  table.insert(typeDef.specializationNames, "MountableAttacher")
					  table.insert(typeDef.specializations, MountableAttacher)  
					end 
				end 
			end   
		end 
	end
end
VehicleTypeManager.finalizeVehicleTypes = Utils.prependedFunction(VehicleTypeManager.finalizeVehicleTypes, MountableAttacher_register.register)
print("----MountableAttacher registered.")

addModEventListener(MountableAttacher_register);